diff --git a/rtemsbsd/rtems/rtems-kernel-capability.c b/rtemsbsd/rtems/rtems-kernel-capability.c
new file mode 100644
index 00000000..3d3787da
--- /dev/null
+++ b/rtemsbsd/rtems/rtems-kernel-capability.c
@@ -0,0 +1,71 @@
+/**
+ * @file
+ *
+ * @ingroup rtems_bsd_rtems
+ *
+ * @brief TODO.
+ */
+
+/*
+ * Copyright (c) 2020 Chris Johns
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <machine/rtems-bsd-kernel-space.h>
+
+#include <sys/types.h>
+#include <sys/caprights.h>
+
+cap_rights_t cap_no_rights;
+
+#define RTEMS_BSD_CAP_ALIAS(var, tar) \
+	extern int __attribute__((alias("_bsd_" #var))) _bsd_##tar;
+
+#ifdef INVARIANT_SUPPORT
+RTEMS_BSD_CAP_ALIAS(cap_no_rights, cap_rights_is_valid);
+#endif
+RTEMS_BSD_CAP_ALIAS(cap_no_rights, cap_accept_rights);
+RTEMS_BSD_CAP_ALIAS(cap_no_rights, cap_bind_rights);
+RTEMS_BSD_CAP_ALIAS(cap_no_rights, cap_connect_rights);
+RTEMS_BSD_CAP_ALIAS(cap_no_rights, cap_event_rights);
+RTEMS_BSD_CAP_ALIAS(cap_no_rights, cap_fcntl_rights);
+RTEMS_BSD_CAP_ALIAS(cap_no_rights, cap_fstat_rights);
+RTEMS_BSD_CAP_ALIAS(cap_no_rights, cap_fsync_rights);
+RTEMS_BSD_CAP_ALIAS(cap_no_rights, cap_ftruncate_rights);
+RTEMS_BSD_CAP_ALIAS(cap_no_rights, cap_getpeername_rights);
+RTEMS_BSD_CAP_ALIAS(cap_no_rights, cap_getsockname_rights);
+RTEMS_BSD_CAP_ALIAS(cap_no_rights, cap_getsockopt_rights);
+RTEMS_BSD_CAP_ALIAS(cap_no_rights, cap_ioctl_rights);
+RTEMS_BSD_CAP_ALIAS(cap_no_rights, cap_listen_rights);
+RTEMS_BSD_CAP_ALIAS(cap_no_rights, cap_mkdirat_rights);
+RTEMS_BSD_CAP_ALIAS(cap_no_rights, cap_mknodat_rights);
+RTEMS_BSD_CAP_ALIAS(cap_no_rights, cap_read_rights);
+RTEMS_BSD_CAP_ALIAS(cap_no_rights, cap_recv_rights);
+RTEMS_BSD_CAP_ALIAS(cap_no_rights, cap_renameat_source_rights);
+RTEMS_BSD_CAP_ALIAS(cap_no_rights, cap_renameat_target_rights);
+RTEMS_BSD_CAP_ALIAS(cap_no_rights, cap_seek_rights);
+RTEMS_BSD_CAP_ALIAS(cap_no_rights, cap_setsockopt_rights);
+RTEMS_BSD_CAP_ALIAS(cap_no_rights, cap_shutdown_rights);
+RTEMS_BSD_CAP_ALIAS(cap_no_rights, cap_symlinkat_rights);
+RTEMS_BSD_CAP_ALIAS(cap_no_rights, cap_write_rights);
diff --git a/rtemsbsd/rtems/rtems-kernel-dev.c b/rtemsbsd/rtems/rtems-kernel-dev.c
new file mode 100644
index 00000000..56180188
--- /dev/null
+++ b/rtemsbsd/rtems/rtems-kernel-dev.c
@@ -0,0 +1,64 @@
+/**
+ * @file
+ *
+ * @ingroup rtems_bsd_rtems
+ *
+ * @brief Handle the major, minor and makedev support
+ */
+
+/*
+ * Copyright (c) 1982, 1986, 1991, 1993, 1994
+ *      The Regents of the University of California.  All rights reserved.
+ * (c) UNIX System Laboratories, Inc.
+ * All or some portions of this file are derived from material licensed
+ * to the University of California by American Telephone and Telegraph
+ * Co. or Unix System Laboratories, Inc. and are reproduced herein with
+ * the permission of UNIX System Laboratories, Inc.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <machine/rtems-bsd-kernel-space.h>
+
+#include <sys/types.h>
+
+int
+rtems_bsd__major(dev_t _d)
+{
+	return (((_d >> 32) & 0xffffff00) | ((_d >> 8) & 0xff));
+}
+
+int
+rtems_bsd__minor(dev_t _d)
+{
+	return (((_d >> 24) & 0xff00) | (_d & 0xffff00ff));
+}
+
+dev_t
+rtems_bsd__makedev(int _M, int _m)
+{
+	return (((dev_t)(_M & 0xffffff00) << 32) | ((_M & 0xff) << 8) |
+	    ((dev_t)(_m & 0xff00) << 24) | (_m & 0xffff00ff));
+}
diff --git a/rtemsbsd/rtems/rtems-kernel-dirent.c b/rtemsbsd/rtems/rtems-kernel-dirent.c
new file mode 100644
index 00000000..4c18b2bc
--- /dev/null
+++ b/rtemsbsd/rtems/rtems-kernel-dirent.c
@@ -0,0 +1,52 @@
+/**
+ * @file
+ *
+ * @ingroup rtems_bsd_rtems
+ *
+ * @brief TODO.
+ */
+
+/*
+ * Copyright (c) 2009, 2015 embedded brains GmbH
+ * All rights reserved.
+ *
+ *  embedded brains GmbH
+ *  Dornierstr. 4
+ *  82178 Puchheim
+ *  Germany
+ *  <rtems@embedded-brains.de>
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <machine/rtems-bsd-kernel-space.h>
+
+#include <sys/dirent.h>
+
+#include <string.h>
+
+void
+dirent_terminate(struct dirent *dp)
+{
+	memset(dp->d_name + dp->d_namlen, 0,
+	    dp->d_reclen - (__offsetof(struct dirent, d_name) + dp->d_namlen));
+}
diff --git a/rtemsbsd/rtems/rtems-kernel-init.c b/rtemsbsd/rtems/rtems-kernel-init.c
index eb958ede..90a9c809 100644
--- a/rtemsbsd/rtems/rtems-kernel-init.c
+++ b/rtemsbsd/rtems/rtems-kernel-init.c
@@ -38,30 +38,37 @@
  */
 
 #include <machine/rtems-bsd-kernel-space.h>
-#include <machine/rtems-bsd-thread.h>
 
-#include <sys/param.h>
 #include <sys/types.h>
+#include <sys/param.h>
 #include <sys/systm.h>
+#include <sys/buf.h>
+#include <sys/filedesc.h>
+#include <sys/jail.h>
+#include <sys/kbio.h>
 #include <sys/kernel.h>
 #include <sys/ktr.h>
-#include <sys/sysctl.h>
 #include <sys/lock.h>
 #include <sys/mutex.h>
 #include <sys/proc.h>
-#include <sys/stat.h>
-#include <sys/kbio.h>
 #include <sys/resourcevar.h>
-#include <sys/jail.h>
-#include <uuid/uuid.h>
+#include <sys/stat.h>
+#include <sys/sx.h>
+#include <sys/sysctl.h>
+#include <sys/sysent.h>
 
-#include <limits.h>
+#include <machine/rtems-bsd-page.h>
+#include <machine/rtems-bsd-thread.h>
 
 #include <dev/kbd/kbdreg.h>
 
 #include <net80211/ieee80211_freebsd.h>
 
+#include <limits.h>
 #include <rtems/bsd/bsd.h>
+#include <rtems/libio_.h>
+#include <rtems/malloc.h>
+#include <uuid/uuid.h>
 
 SYSINIT_REFERENCE(configure1);
 SYSINIT_REFERENCE(module);
@@ -98,25 +105,47 @@ sbintime_t sbt_timethreshold;
 sbintime_t sbt_tickthreshold;
 struct bintime tc_tick_bt;
 sbintime_t tc_tick_sbt;
-int maxproc;
 int tc_precexp;
-
-static SYSCTL_NODE(_kern, OID_AUTO, smp, CTLFLAG_RD|CTLFLAG_CAPRD, NULL,
-    "Kernel SMP");
+int maxproc;
+int maxfiles;
+int maxfilesperproc;
+int ngroups_max;
+int unmapped_buf_allowed;
+caddr_t unmapped_base;
+long maxbcache;
+int bio_transient_maxcnt;
+struct sx allproc_lock;
+struct vmem *rtems_bsd_transient_arena;
+int nbuf;   /* The number of buffer headers */
+int nswbuf; /* Number of swap I/O buffer headers. */
+void (*nlminfo_release_p)(struct proc *p);
+struct sysentvec rtems_sysvec;
+
+static SYSCTL_NODE(
+    _kern, OID_AUTO, smp, CTLFLAG_RD | CTLFLAG_CAPRD, NULL, "Kernel SMP");
 
 static int maxid_maxcpus;
 
-SYSCTL_INT(_kern_smp, OID_AUTO, maxid, CTLFLAG_RD|CTLFLAG_CAPRD,
+SYSCTL_INT(_kern_smp, OID_AUTO, maxid, CTLFLAG_RD | CTLFLAG_CAPRD,
     &maxid_maxcpus, 0, "Max CPU ID.");
 
-SYSCTL_INT(_kern_smp, OID_AUTO, maxcpus, CTLFLAG_RD|CTLFLAG_CAPRD,
+SYSCTL_INT(_kern_smp, OID_AUTO, maxcpus, CTLFLAG_RD | CTLFLAG_CAPRD,
     &maxid_maxcpus, 0, "Max number of CPUs that the system was compiled for.");
 
+static void
+cpu_startup(void *dummy)
+{
+	kern_vfs_bio_buffer_alloc(unmapped_base, maxbcache);
+	bufinit();
+	vm_pager_bufferinit();
+}
+SYSINIT(cpu, SI_SUB_CPU, SI_ORDER_FIRST, cpu_startup, NULL);
+
 /*
  * Create a single process. RTEMS is a single address, single process OS.
  */
 static void
-proc0_init(void* dummy)
+proc0_init(void *dummy)
 {
 	struct proc *p = &proc0;
 	struct ucred *newcred;
@@ -127,7 +156,7 @@ proc0_init(void* dummy)
 	newcred = crget();
 	newcred->cr_uid = 0;
 	newcred->cr_ruid = 0;
-	newcred->cr_ngroups = 1;	/* group 0 */
+	newcred->cr_ngroups = 1; /* group 0 */
 	newcred->cr_groups[0] = 0;
 	newcred->cr_rgid = 0;
 	tmpuinfo.ui_uid = 1;
@@ -137,8 +166,15 @@ proc0_init(void* dummy)
 	newcred->cr_ruidinfo = uifind(0);
 	p->p_ucred = newcred;
 	p->p_pid = getpid();
-	p->p_fd = NULL;
+	p->p_fd = fdinit(NULL, false);
 	p->p_fdtol = NULL;
+	rtems_sysvec.sv_flags = SV_ABI_FREEBSD;
+#ifdef __LP64__
+	rtems_sysvec.sv_flags |= SV_LP64;
+#else
+	rtems_sysvec.sv_flags |= SV_ILP32;
+#endif
+	p->p_sysent = &rtems_sysvec;
 	uuid_generate(uuid);
 	uuid_unparse(uuid, prison0.pr_hostuuid);
 }
@@ -170,17 +206,27 @@ rtems_bsd_initialize(void)
 	bt_tickthreshold = bt_timethreshold;
 	sbt_timethreshold = bttosbt(bt_timethreshold);
 	sbt_tickthreshold = bttosbt(bt_tickthreshold);
-	maxid_maxcpus = (int) rtems_scheduler_get_processor_maximum();
+	maxid_maxcpus = (int)rtems_scheduler_get_processor_maximum();
+	bio_transient_maxcnt = 1024;
+	sx_init(&allproc_lock, "allproc");
 
+	maxfiles = rtems_libio_number_iops;
+	maxfilesperproc = maxfiles;
 	maxproc = 16;
+	ngroups_max = 4;
+
+	maxbcache = rtems_bsd_get_allocator_domain_size(
+	    RTEMS_BSD_ALLOCATOR_DOMAIN_BIO);
+	unmapped_base = (caddr_t)rtems_heap_allocate_aligned_with_boundary(
+	    maxbcache, CACHE_LINE_SIZE, 0);
+	if (unmapped_base == NULL) {
+		return RTEMS_UNSATISFIED;
+	}
 
 	mkdir("/etc", S_IRWXU | S_IRWXG | S_IRWXO);
 
-	sc =  rtems_timer_initiate_server(
-		rtems_bsd_get_task_priority(name),
-		rtems_bsd_get_task_stack_size(name),
-		RTEMS_DEFAULT_ATTRIBUTES
-	);
+	sc = rtems_timer_initiate_server(rtems_bsd_get_task_priority(name),
+	    rtems_bsd_get_task_stack_size(name), RTEMS_DEFAULT_ATTRIBUTES);
 	if (sc != RTEMS_SUCCESSFUL) {
 		return RTEMS_UNSATISFIED;
 	}
@@ -191,7 +237,8 @@ rtems_bsd_initialize(void)
 #ifdef KTR
 	ktr_verbose = 10;
 	ktr_mask = KTR_ALL;
-	ktr_mask = KTR_GEN | KTR_LOCK | KTR_VFS | KTR_VOP | KTR_BUF | KTR_MALLOC | KTR_SYSC | KTR_RUNQ;
+	ktr_mask = KTR_GEN | KTR_LOCK | KTR_VFS | KTR_VOP | KTR_BUF |
+	    KTR_MALLOC | KTR_SYSC | KTR_RUNQ;
 #endif
 
 	return RTEMS_SUCCESSFUL;
diff --git a/rtemsbsd/rtems/rtems-kernel-pager.c b/rtemsbsd/rtems/rtems-kernel-pager.c
new file mode 100644
index 00000000..5a48c2e8
--- /dev/null
+++ b/rtemsbsd/rtems/rtems-kernel-pager.c
@@ -0,0 +1,171 @@
+/**
+ * @file
+ *
+ * @ingroup rtems_bsd_rtems
+ *
+ * @brief TODO.
+ */
+
+/*
+ * Copyright (c) 2020 Chris Johns <chris@contemporary.software>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <machine/rtems-bsd-kernel-space.h>
+
+#include <sys/param.h>
+#include <sys/buf.h>
+#include <sys/kernel.h>
+#include <sys/vmem.h>
+
+#include <vm/vm.h>
+#include <vm/uma.h>
+#include <vm/vm_extern.h>
+
+#define B_MAXPHYS 0x00200000 /* nitems(b_pages[]) = atop(MAXPHYS). */
+#define PBUF_PAGES (atop(maxphys) + 1)
+#define MAXPHYS (128 * 1024)
+#define NSWBUF_MIN 16
+
+static u_long maxphys; /* max raw I/O transfer size */
+static int nswbuf_max;
+
+vmem_t *kernel_arena;
+uma_zone_t pbuf_zone;
+uma_zone_t ncl_pbuf_zone;
+
+vm_offset_t
+kva_alloc(vm_size_t size)
+{
+	vm_offset_t addr;
+
+	size = round_page(size);
+	if (vmem_alloc(kernel_arena, size, M_BESTFIT | M_NOWAIT, &addr))
+		return (0);
+
+	return (addr);
+}
+
+static int
+pbuf_ctor(void *mem, int size, void *arg, int flags)
+{
+	struct buf *bp = mem;
+
+	bp->b_vp = NULL;
+	bp->b_bufobj = NULL;
+
+	/* copied from initpbuf() */
+	bp->b_rcred = NOCRED;
+	bp->b_wcred = NOCRED;
+	bp->b_qindex = 0; /* On no queue (QUEUE_NONE) */
+	bp->b_data = bp->b_kvabase;
+	bp->b_xflags = 0;
+	bp->b_flags = B_MAXPHYS;
+	bp->b_ioflags = 0;
+	bp->b_iodone = NULL;
+	bp->b_error = 0;
+	BUF_LOCK(bp, LK_EXCLUSIVE, NULL);
+
+	return (0);
+}
+
+static void
+pbuf_dtor(void *mem, int size, void *arg)
+{
+	struct buf *bp = mem;
+
+	if (bp->b_rcred != NOCRED) {
+		crfree(bp->b_rcred);
+		bp->b_rcred = NOCRED;
+	}
+	if (bp->b_wcred != NOCRED) {
+		crfree(bp->b_wcred);
+		bp->b_wcred = NOCRED;
+	}
+
+	BUF_UNLOCK(bp);
+}
+
+static int
+pbuf_init(void *mem, int size, int flags)
+{
+	struct buf *bp = mem;
+
+	bp->b_kvabase = (void *)kva_alloc(ptoa(PBUF_PAGES));
+	if (bp->b_kvabase == NULL)
+		return (ENOMEM);
+	bp->b_kvasize = ptoa(PBUF_PAGES);
+	BUF_LOCKINIT(bp);
+	LIST_INIT(&bp->b_dep);
+	bp->b_rcred = bp->b_wcred = NOCRED;
+	bp->b_xflags = 0;
+
+	return (0);
+}
+
+void
+vm_pager_bufferinit(void)
+{
+	/* Main zone for paging bufs. */
+	pbuf_zone = uma_zcreate("pbuf",
+	    sizeof(struct buf) + PBUF_PAGES * sizeof(vm_page_t), pbuf_ctor,
+	    pbuf_dtor, pbuf_init, NULL, UMA_ALIGN_CACHE, UMA_ZONE_NOFREE);
+	/* Few systems may still use this zone directly, so it needs a limit. */
+	nswbuf_max += uma_zone_set_max(pbuf_zone, NSWBUF_MIN);
+}
+
+uma_zone_t
+pbuf_zsecond_create(char *name, int max)
+{
+	uma_zone_t zone;
+
+	zone = uma_zsecond_create(
+	    name, pbuf_ctor, pbuf_dtor, NULL, NULL, pbuf_zone);
+	/*
+	 * uma_prealloc() rounds up to items per slab. If we would prealloc
+	 * immediately on every pbuf_zsecond_create(), we may accumulate too
+	 * much of difference between hard limit and prealloced items, which
+	 * means wasted memory.
+	 */
+	if (nswbuf_max > 0)
+		nswbuf_max += uma_zone_set_max(zone, max);
+	else
+		uma_prealloc(pbuf_zone, uma_zone_set_max(zone, max));
+
+	return (zone);
+}
+
+struct buf *
+getpbuf(int *pfreecnt)
+{
+	(void)pfreecnt;
+	return uma_zalloc(ncl_pbuf_zone, M_WAITOK);
+}
+
+void
+relpbuf(struct buf *bp, int *pfreecnt)
+{
+	(void)pfreecnt;
+	uma_zfree(ncl_pbuf_zone, bp);
+}
diff --git a/rtemsbsd/rtems/rtems-kernel-param.c b/rtemsbsd/rtems/rtems-kernel-param.c
new file mode 100644
index 00000000..f8fb2dd7
--- /dev/null
+++ b/rtemsbsd/rtems/rtems-kernel-param.c
@@ -0,0 +1,40 @@
+/**
+ * @file
+ *
+ * @ingroup rtems_bsd_rtems
+ *
+ * @brief TODO.
+ */
+
+/*
+ * Copyright (c) 2020 Chris Johns <chris@contemporary.software>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <machine/rtems-bsd-kernel-space.h>
+
+#include <sys/types.h>
+#include <sys/systm.h>
+
+int ngroups_max; /* max # of supplemental groups */
